#
# 2014.10.13 jdwang@asia.edu.tw
#
# usage : perl PubMed_InfoExtration_7_MultiArticle10.pl

use strict;
use Data::Dumper;


my $SrcDir = "../SrcData";
my $InputFileName = "pubmed_result_WilsonDisease_jdwang2014_10_9.xml";


my $OutputDir = "../SrcData_ParsedNew";
my ($FileName, $Ext) = $InputFileName =~ /(.+)\.(.+)?/;
#print Dumper($FileName, $Ext);exit;
my $OutputFileName = "$FileName"."_Parsed.txt";

print "begin $InputFileName ".scalar localtime(time())."\n";#exit;

ParsePubMed_XMLFile($SrcDir,$InputFileName,$OutputDir,$OutputFileName);

print "end $InputFileName ".scalar localtime(time())."\n";


#####################################################################
#
#
#####################################################################

sub ParsePubMed_XMLFile() {
	
	my ($SrcDataDir,$InputFileName,$OutputDir,$OutputFileName) = @_;
	
	
	my $FileLocation = "$SrcDataDir/$InputFileName";
	open (FILEHANDLE,$FileLocation) or die "can't open $FileLocation";
				
	
	mkdir $OutputDir;					
	my $OutputFileLocation = "$OutputDir/$OutputFileName";
				
	open (Output,">$OutputFileLocation");
			
	#
	# Initial the statistis of PubMed Articles
	#	
	print "begin $FileLocation ".scalar localtime(time())."\n";#exit;
	
	my $TotalLen = 0;
	my $NewsCnt = 0;
	my $FileOver = 0; # Not ture 
	my $Linecnt = 0;
	while ((my $Line = <FILEHANDLE>) && ($FileOver==0))
	{   
			#print "$Line";
			$Linecnt++;
			my $OneArticle = "";
			if ($Line =~ /<PubmedArticle>/) {
				#print "(NewsCnt=$NewsCnt) Begin  $Linecnt =>$Line\n"; #exit;	
				$NewsCnt ++;
				chomp($Line);									
				$OneArticle = $Line;
				my $FoundEndNew = 0;
				#while ( (my $Line2 = <FILEHANDLE> )  &&  ($FoundEndNew == 0 ) && ($FileOver==0) ){
				while ( (my $Line2 = <FILEHANDLE> ) && ($FoundEndNew == 0 ) ){
					$Linecnt++;
					if ($Line =~ /<\/PubmedArticleSet>/) {
				   		$FileOver=1;
					} else {
						chomp($Line2);
						$OneArticle= $OneArticle.$Line2;
						 if ($Line2 =~ /<\/PubmedArticle>/) {
							 $FoundEndNew = 1;
							 #print "End  $Linecnt =>$Line2\n"; #exit;	
						} # end of 
					} # end of if ($Line =~ /<\/PubmedArticleSet>/) {
				} # end of while ($Line = <FILEHANDLE>)&&($FoundEndNew == 0)) {
				#print "$OneArticle\n";exit;
				if ($FoundEndNew == 1) {
					my ($OneArticleStr) = $OneArticle =~  /<PubmedArticle>(.+)<\/PubmedArticle>/;			
					
					#print output "$NewsCnt##$OneArticle1\n";
					my %OneArticleInfo = (); # Hash for storing the information of one article								
					ExtractArticleInfo($OneArticleStr,\%OneArticleInfo);
					#print Dumper(\%OneArticleInfo);exit;
					
					print Output "$OneArticleInfo{'PMID'}##$OneArticleInfo{'year'}-$OneArticleInfo{'month'}-$OneArticleInfo{'day'}##$OneArticleInfo{'ArticleTitle'}##$OneArticleInfo{'AbstractText'}\n";
								
				} else {
					$FileOver=1;
				}
				
			} elsif ($Line =~ /<\/PubmedArticleSet>/) { # end of PubMed XML file
				$FileOver=1;
			}		
	} # end of while ((my $Line = <FILEHANDLE>) && ($FileOver==0))
	print "end $FileLocation ".scalar localtime(time())."\n";
	close(FILEHANDLE);
	close(Output);

}

###########################################################
#
#
#
###########################################################
sub ExtractArticleInfo {
	my ($OneArticleStr,$OneArticleInfo) = @_;
	#print "(ExtractArticleInfo)\n$OneArticleStr\n";exit;
	
	# Extract "PMID"	
	if ($OneArticleStr =~ /<PMID>(\d+)<\/PMID>/ ){	
		$OneArticleInfo->{'PMID'} = $1;
	}	elsif ($OneArticleStr =~ /<PMID Version="\d+">(\d+)<\/PMID>/ ){
		$OneArticleInfo->{'PMID'} = $1;
	}   else {
		print "Error PMID format=>$OneArticleStr\n";exit;
	}
	#print Dumper($OneArticleInfo);exit;
	#
	# Extract the "Abstract"
	#
	if ($OneArticleStr =~ /<AbstractText>(.+)<\/AbstractText>/ ){
		$OneArticleInfo->{'AbstractText'} = $1;
	} elsif ($OneArticleStr =~ /<AbstractText NlmCategory=\"\w+\">(.+)<\/AbstractText>/){
		$OneArticleInfo->{'AbstractText'} = $1;
	} elsif (($OneArticleStr =~ /<AbstractText Label=\".+\" NlmCategory=\"\w+\">(.+)<\/AbstractText>/)) {
		# PMID = 25291347;
		#<AbstractText Label="GOALS:" NlmCategory="UNASSIGNED">To determine the prevalence and characteristics of lipomas in patients with Wilson disease.</AbstractText>
        #<AbstractText Label="BACKGROUND:" NlmCategory="UNASSIGNED">Wilson disease is an autosomal recessive disorder resulting in copper accumulation in the liver and the central nervous tissue. Subcutaneous lipomas were often noted by the authors during clinical examinations of patients with Wilson disease. This is the first study to analyze the prevalence and progression of lipoma development in patients with Wilson disease.</AbstractText>
        #<AbstractText Label="STUDY:" NlmCategory="UNASSIGNED">Eighty consecutive patients attending a tertiary care center were examined for the presence of subcutaneous lipomas.</AbstractText>
        #<AbstractText Label="RESULTS:" NlmCategory="UNASSIGNED">Subcutaneous lipomas could be detected during the examination of 21 (26%) of the 80 patients with Wilson disease. Multiple subcutaneous lipomas were present in 16 (76%) of the 21 affected patients. Lipomas were mainly found on the extremities and the trunk. Neither initial presentation nor decoppering treatment influenced the presence or course of lipomas in these patients.</AbstractText>
        #<AbstractText Label="CONCLUSIONS:" NlmCategory="UNASSIGNED">Subcutaneous lipoma formation is more common in patients with Wilson disease than in the general population. We suggest that the presence of lipomas contributes to the differential diagnosis of Wilson disease.</AbstractText>        
        my ($TempStr) =  $OneArticleStr  =~ /<Abstract>(.+)<\/Abstract>/;
        #print Dumper($TempStr);#exit;
	
        my @Items = split (/<\/AbstractText>/,$TempStr);
        #print Dumper(@Item);exit;
        my $TempStr = "";
        foreach my $OneItem (@Items) {
	        #print "$OneItem\n";exit;
	        my ($Temp) = $OneItem =~ /<AbstractText Label=\".+\" NlmCategory=\"\w+\">(.+)/;
	        #print "$Temp\n\n";exit;
	        $TempStr = $TempStr.$Temp." ";
        }     
        #print Dumper($TempStr);exit;     
        $OneArticleInfo->{'AbstractText'} = $TempStr;
    } else {
		#print "PMID=$OneArticleInfo->{'PMID'} Error=>Abstract\n";
		#exit;
	} # end of if ($OneArticleStr =~ /<AbstractText>(.+)<\/AbstractText>/ )
	#
	# Extract the "Title"
	#
	if ($OneArticleStr =~ /<ArticleTitle>(.+)<\/ArticleTitle>/ ){
		$OneArticleInfo->{'ArticleTitle'} = $1;
	} else {
		$OneArticleInfo->{'ArticleTitle'} = "";#exit;
	}
	#print Dumper($OneArticleInfo);exit;
	#
	# Extract the PubDate "Year Month Day"
	#
	my ($TargetDateStr) = $OneArticleStr =~ /<PubMedPubDate PubStatus="\w+">(.+)<\/PubMedPubDate>/;	
	if ($TargetDateStr ne '') {
		$TargetDateStr =~ s/ //g;			
		my ($year,$month,$day) = $TargetDateStr =~ /<Year>(\d+)<\/Year><Month>(\d+)<\/Month><Day>(\d+)<\/Day>/;		
		#print Dumper($year,$Month,$day);exit;	
		
		if (length($year)==4) {
			$OneArticleInfo->{'year'} = $year;		
			$OneArticleInfo->{'month'} = $month;		
			$OneArticleInfo->{'day'} = $day;			
			#print Dumper($OneArticleInfo);exit;				
		} else {
			print "FindPubDate=>(PID:$OneArticleInfo->{'PMID'})(Year:$year)!\n";exit;
		} # end of if (length($year)==4
	} else {
		print "$OneArticleInfo->{'PMID'}=>TargetDateStr: Error \n"; exit;
	}	# end of if ($TargetDateStr ne '') 
} # end of sub ExtractArticleInfo